---
title: ImageCapture.grabFrame()
slug: Web/API/ImageCapture/grabFrame
tags:
  - API
  - Experimental
  - Image
  - Image Capture
  - ImageCapture
  - Media
  - MediaStream Image Capture API
  - Method
  - Reference
  - grapFrame
---
<div>{{APIRef("MediaStream Image")}}</div>

<p><span class="seoSummary">The <strong><code>grabFrame()</code></strong> method of the {{domxref("ImageCapture")}} interface takes a snapshot of the live video in a {{domxref("MediaStreamTrack")}} and returns a {{jsxref("Promise")}} that resolves with a {{domxref("ImageBitmap")}} containing the snapshot.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">const <em>bitmapPromise</em> = <em>imageCapture</em>.grabFrame()
</pre>

<h3 id="Return_value"><span style='font-family: x-locale-heading-primary,zillaslab,Palatino,"Palatino Linotype",x-locale-heading-secondary,serif; font-size: 1.375rem;'>Return value</span></h3>

<p>A {{jsxref("Promise")}} that resolves to an {{domxref("ImageBitmap")}} object.</p>

<h2 id="Example">Example</h2>

<p>This example is extracted from this <a href="https://simpl.info/imagecapture/">Simple Image Capture demo</a>. It shows how to use the {{jsxref("Promise")}} returned by <code>grabFrame()</code> to copy the returned frame to a {{htmlelement("canvas")}} element. For simplicy it does not show how to instantiate the {{domxref("ImageCapture")}} object.</p>

<pre class="brush: js">var grabFrameButton = document.querySelector('button#grabFrame');
var canvas = document.querySelector('canvas');

grabFrameButton.onclick = grabFrame;

function grabFrame() {
  imageCapture.grabFrame()
  .then(function(imageBitmap) {
    console.log('Grabbed frame:', imageBitmap);
    canvas.width = imageBitmap.width;
    canvas.height = imageBitmap.height;
    canvas.getContext('2d').drawImage(imageBitmap, 0, 0);
    canvas.classList.remove('hidden');
  })
  .catch(function(error) {
    console.log('grabFrame() error: ', error);
  });
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('MediaStream Image','#dom-imagecapture-grabframe','grabFrame()')}}</td>
   <td>{{Spec2('MediaStream Image')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.ImageCapture.grabFrame")}}</p>
</div>
